Package org.apache.coyote.ajp

# Class AjpProcessor.SocketOutputBuffer

java.lang.Object
org.apache.coyote.ajp.AjpProcessor.SocketOutputBuffer

All Implemented Interfaces:
  `OutputBuffer`

Enclosing class:
  `AjpProcessor`

protected class AjpProcessor.SocketOutputBuffer extends Object implements OutputBuffer
This class is an output buffer which will write data to an output stream.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`SocketOutputBuffer()`

## Method Summary

Modifier and Type
Method
Description
`int`
`doWrite(ByteBuffer chunk)`
Write the given data to the response.
`long`
`getBytesWritten()`
Bytes written to the underlying socket.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### SocketOutputBuffer

protected SocketOutputBuffer()

## Method Details

### doWrite

public int doWrite(ByteBuffer chunk) throws IOException
Description copied from interface: `OutputBuffer`
Write the given data to the response. The caller owns the chunks.

Specified by:
  `doWrite` in interface `OutputBuffer`
Parameters:
  `chunk` - data to write
Returns:
  The number of bytes written which may be less than available in the input chunk
Throws:
  `IOException` - an underlying I/O error occurred

### getBytesWritten

public long getBytesWritten()
Description copied from interface: `OutputBuffer`
Bytes written to the underlying socket. This includes the effects of chunking, compression, etc.

Specified by:
  `getBytesWritten` in interface `OutputBuffer`
Returns:
  Bytes written for the current request